# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.ransim_metrics import RansimMetrics  # noqa: F401,E501
from swagger_server import util


class RansimEditableParameters(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, metrics: List[RansimMetrics]=None, remote_output_file_path: str=None, remote_input_files_path: List[str]=None, topic_name: str=None):  # noqa: E501
        """RansimEditableParameters - a model defined in Swagger

        :param metrics: The metrics of this RansimEditableParameters.  # noqa: E501
        :type metrics: List[RansimMetrics]
        :param remote_output_file_path: The remote_output_file_path of this RansimEditableParameters.  # noqa: E501
        :type remote_output_file_path: str
        :param remote_input_files_path: The remote_input_files_path of this RansimEditableParameters.  # noqa: E501
        :type remote_input_files_path: List[str]
        :param topic_name: The topic_name of this RansimEditableParameters.  # noqa: E501
        :type topic_name: str
        """
        self.swagger_types = {
            'metrics': List[RansimMetrics],
            'remote_output_file_path': str,
            'remote_input_files_path': List[str],
            'topic_name': str
        }

        self.attribute_map = {
            'metrics': 'metrics',
            'remote_output_file_path': 'remote-output-file-path',
            'remote_input_files_path': 'remote-input-files-path',
            'topic_name': 'topic-name'
        }
        self._metrics = metrics
        self._remote_output_file_path = remote_output_file_path
        self._remote_input_files_path = remote_input_files_path
        self._topic_name = topic_name

    @classmethod
    def from_dict(cls, dikt) -> 'RansimEditableParameters':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ransim-editable-parameters of this RansimEditableParameters.  # noqa: E501
        :rtype: RansimEditableParameters
        """
        return util.deserialize_model(dikt, cls)

    @property
    def metrics(self) -> List[RansimMetrics]:
        """Gets the metrics of this RansimEditableParameters.

        List of the metrics to be retrieved for this datasource.  # noqa: E501

        :return: The metrics of this RansimEditableParameters.
        :rtype: List[RansimMetrics]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics: List[RansimMetrics]):
        """Sets the metrics of this RansimEditableParameters.

        List of the metrics to be retrieved for this datasource.  # noqa: E501

        :param metrics: The metrics of this RansimEditableParameters.
        :type metrics: List[RansimMetrics]
        """

        self._metrics = metrics

    @property
    def remote_output_file_path(self) -> str:
        """Gets the remote_output_file_path of this RansimEditableParameters.

        Path of the output file on the RAN simulator machine  # noqa: E501

        :return: The remote_output_file_path of this RansimEditableParameters.
        :rtype: str
        """
        return self._remote_output_file_path

    @remote_output_file_path.setter
    def remote_output_file_path(self, remote_output_file_path: str):
        """Sets the remote_output_file_path of this RansimEditableParameters.

        Path of the output file on the RAN simulator machine  # noqa: E501

        :param remote_output_file_path: The remote_output_file_path of this RansimEditableParameters.
        :type remote_output_file_path: str
        """

        self._remote_output_file_path = remote_output_file_path

    @property
    def remote_input_files_path(self) -> List[str]:
        """Gets the remote_input_files_path of this RansimEditableParameters.

        List of the paths of the input files on the RAN simulator machine  # noqa: E501

        :return: The remote_input_files_path of this RansimEditableParameters.
        :rtype: List[str]
        """
        return self._remote_input_files_path

    @remote_input_files_path.setter
    def remote_input_files_path(self, remote_input_files_path: List[str]):
        """Sets the remote_input_files_path of this RansimEditableParameters.

        List of the paths of the input files on the RAN simulator machine  # noqa: E501

        :param remote_input_files_path: The remote_input_files_path of this RansimEditableParameters.
        :type remote_input_files_path: List[str]
        """

        self._remote_input_files_path = remote_input_files_path

    @property
    def topic_name(self) -> str:
        """Gets the topic_name of this RansimEditableParameters.

        Name of the topic in which the requested metrics retrieved by this datasource will be published. If empty the topic name will follow a common pattern.  # noqa: E501

        :return: The topic_name of this RansimEditableParameters.
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name: str):
        """Sets the topic_name of this RansimEditableParameters.

        Name of the topic in which the requested metrics retrieved by this datasource will be published. If empty the topic name will follow a common pattern.  # noqa: E501

        :param topic_name: The topic_name of this RansimEditableParameters.
        :type topic_name: str
        """

        self._topic_name = topic_name
